/* 
 * CSE142, 99 Winter
 * Homework 5
 * Valentine's Day: The whole thing
 *
 * Author:     Lisa Tuttle
 * Student ID: 9826652
 * Section:    BF
*/
#include "gp142.h"
#include <math.h>
#include <time.h>
	/* <time.h> is here only so that one function can be called
	to seed the random number generator.
	Put it here in your program and forget about it, 
	just in case you decide later you need to use random numbers.
	*/

#define TRUE    		1
#define FALSE   		0

/*
 * The state, or status you are in determines what happens when you click 
 * the card:
 * ADD SHAPE   -- you click the card, and a new object is placed there.
 *                You get into this mode by clicking an ADD button.
 *                After doing an ADD, you are put into SELECTED mode.
 * SELECTED    -- An object is selected. In this mode, the type 
 *                rotation applies to thecurrent object.
 */
#define STATUS_ADD_SHAPE 1
#define STATUS_SELECTED 2
#define STATUS_ADD_MESSAGE 3
#define STATUS_SELECT_OBJECT 4
#define STATUS_DELETE_OBJECT 5

/* Configure the appearance of the buttons on the menu bar 
 * by setting the number of pixels of button height and width
 */
#define BUTTON_HEIGHT  	35
#define BUTTON_WIDTH 	100

/*Number of buttons to be drawn/used and selection color*/
#define NUM_BUTTONS 	7
#define SELECTED_COLOR  RED

/* Position of the card in the window */
#define PAGE_LLX (-GP142_XMAX + BUTTON_WIDTH +60)
#define PAGE_LLY (-GP142_YMAX + 100)
#define PAGE_WIDTH (GP142_XMAX - PAGE_LLX - 80)
#define PAGE_HEIGHT (GP142_YMAX - PAGE_LLY - 50)

/* For many of the GP142 functions, a line width of
 * zero means to fill the shape being drawn.
 */
#define FILL 0
#define NOFILL 1

/* Types of objects we support.  (Perhaps not all types are used yet.)*/
#define OBJECT_NONE 0
#define OBJECT_SHAPE 1
#define OBJECT_MESSAGE 2

#define MAX_OBJECTS 1000
/*if you add new types, you may need to change this*/
#define MAX_SHAPES 4
#define FIRST_SHAPE_NUM 0
/* These are the kinds of shapes we support.  You'll need to add more. */
#define SHAPE_HEART 0
#define SHAPE_STAR  1
#define SHAPE_SUPERSTAR 2
#define SHAPE_BALLOON 3

/*if you add new types, you may need to change this*/
#define MAX_MESSAGES 5
#define FIRST_MESSAGE_NUM 0
/* These are the kinds of messages we support.  You'll need to add more. */
#define MESSAGE_ZERO 0
#define MESSAGE_ONE 1
#define MESSAGE_TWO 2
#define MESSAGE_THREE 3
#define MESSAGE_FOUR 4


/*Possible places for mouse clicks*/
#define CLICK_BUTTON 1  /* You clicked on SOME button (doesn't say which one)*/
#define CLICK_CARD 2    /* You clicked in the card area */
#define CLICK_OUTSIDE 3	/* You clicked outside the card area, not on a button*/	


/*******************  FUNCTION PROTOTYPES **************************/

/* Drawing functions */
void DrawBlankScreen (void);
void DrawButtons(int last_button);
void DrawCard (int background_color, int status, int object_count, 
			   int object_type[MAX_OBJECTS], int object_num[MAX_OBJECTS], 
			   int object_color[MAX_OBJECTS], int object_x[MAX_OBJECTS], int object_y[MAX_OBJECTS]);
void DrawShape(int shape_type, int color, int bottom_x, int bottom_y);
void DrawHeart (int x, int y, int color);
void DrawStar (int x, int y, int color);
void DrawSuperStar (int x, int y, int color);
void DrawBalloon (int x, int y, int color);

void DrawMessage (int message_type, int color, int bottom_x, int bottom_y);
void DrawText1 (int x, int y, int color);
void DrawText2 (int x, int y, int color);
void DrawText3 (int x, int y, int color);
void DrawText4 (int x, int y, int color);
void DrawText5 (int x, int y, int color);

void DrawCupid (int color);

/*used to select object*/
int ObjectSelect (int mouse_x, int mouse_y, int object_count, int object_x[MAX_OBJECTS], int object_y[MAX_OBJECTS]);
double PointDistance (int x1, int y1, int x2, int y2);

/* Mouse click handling functions */
void HandleMouseClick(int mouse_x, int mouse_y, int *background_color, 
					  int *status, int *object_count, int object_type[MAX_OBJECTS], 
					  int object_num[MAX_OBJECTS], int object_color[MAX_OBJECTS], 
					  int object_x[MAX_OBJECTS], int object_y[MAX_OBJECTS], 
					  int *last_button, int *selected_object);
int ClassifyMouseClick(int mouse_x, int mouse_y);
void HandleButton(int x, int y, int *background_color, int *status,
				  int *object_count, int object_type[MAX_OBJECTS], int object_num[MAX_OBJECTS], 
				  int object_color[MAX_OBJECTS], int object_x[MAX_OBJECTS], int object_y[MAX_OBJECTS],
				  int *last_button, int *selected_object);

/* Add a shape to the card. */
void AddShape(int x, int y, int *status, int *object_count, int *selected_object,
			   int object_type[MAX_OBJECTS], int object_num[MAX_OBJECTS], int object_color[MAX_OBJECTS], 
			   int object_x[MAX_OBJECTS], int object_y[MAX_OBJECTS]);

/*****************************************************************************

     MAIN

*****************************************************************************/

/* main() has two chief purposes: to contain the important variables and 
 *initialize them, and to contain the "event loop," which constantly looks 
 *to see if an event has happened, and then processes the event by calling 
 *an appropriate function. An example of an event is a mouse click.
 */
int main(void)
{
	int quit = FALSE;              /* becomes TRUE to exit program */
	int mouse_x, mouse_y;          /* coordinates of a mouse click */
	char key_hit;                  /* which key was hit            */
	
	
	/*variables and their default values*/
	int background_color = YELLOW;
	int status = STATUS_ADD_SHAPE;
	
	/* Each object will have a number telling what kind of object it is, a color,
	 * and an x and y coordinate.  You'll need to make these into arrays so you
	 * can support more than one object.
	 */
	int object_count = 0;           /* How many objects on the page? */
	int object_type[MAX_OBJECTS];   /* Can also be a shape           */
	int object_num[MAX_OBJECTS];    /* If type is shape, either 
									   heart or star                 */
	int object_color[MAX_OBJECTS];  /* Color of object               */
	int object_x[MAX_OBJECTS];      /* Position of object            */
	int object_y[MAX_OBJECTS];
	int i;							/*used for the loop to initialize object_'s */
	int last_button = 0;            /* Keep track of the last button clicked.
	                                   This would be usefull when highlighting
	                                   the last button the user clicked */
	int selected_object = 0;		/*number that corresponds to the subscript of the
									  array data to be changed*/

	int event; /*the most recent GP142 event*/
	
	time_t t; /*needed only when initializing a random number generator*/
	

	/*
	 * INITIALIZATIONS
	 */
	srand (time(&t));	    /* Seed the random number generator. This is 
							   something you should do if you plan to use 
							   random numbers. Leave it here in your program 
							   and forget about it.*/

	/*clear the initial values of the array variables*/
	for (i=0; i<MAX_OBJECTS; i++) {
		object_type[i] = OBJECT_NONE;
		object_num [i] = 0;
		object_color[i] = RED;
		object_x[i] = 0;
		object_y[i] = 0;
	}
	

	/* These GP142 initializations don't need to be changed */
	GP142_open();           /* Open and init the GP142 Graphics Window      */
	GP142_show_text(0);     /* Hide the text window                         */
	GP142_logging(LOG_OFF); /* Change to LOG_ON if you want it.             */
	
	GP142_clear();	        /* This will clear the window & paint it white. */
	GP142_animate(ANI_RUN); /* Enable periodic events                       */
	
	
	
	/*
	 * The main event loop:
	 * --- ---- ----- -----
	 * wait for the next user action, such as a mouse click or keyboard
	 * keypress, or a periodic update event (allowing us to display the
	 * next frame of an animation -- not used directly in this program)
	 * and call the appropriate function to handle it.  Repeat this until 
	 * the user signals "quit".
	 */
	while (!quit) {  /*this is the famous "event loop" */
		
		/*start by redrawing everything */
		DrawBlankScreen ();
		DrawCard (background_color, status, object_count, 
			      object_type, object_num, object_color,
				  object_x, object_y);
		DrawButtons(last_button);	  /* Show the buttons...*/ 
		
		/*Wait for something to happen */
		event = GP142_await_event(&mouse_x, &mouse_y, &key_hit);
		
		/* Something just happened.  Figure out what it was, and react 
		   appropriately. */
		switch (event) {
		case GP142_QUIT:
			quit = TRUE;           /* set flag to terminate loop           */
			break;
			
		case GP142_KBD:  /*A key was pressed */
			/*not needed for this program. Use this if user will need to 
			  hit a key. Note that scanf CANNOT be used with GP142.  If you 
			  use this, the key character value is in variable "key_hit"*/
			break;
			
		case GP142_MOUSE:
			/* A mouse click has occurred. Call the mouse handler to 
			   decide where the click was and react as needed. */
			HandleMouseClick(mouse_x, mouse_y, &background_color, &status, 
					         &object_count, object_type, 
							 object_num, object_color, 
							 object_x, object_y, &last_button, &selected_object);			
			break;
			
		case GP142_PERIODIC:
			/*An events has occurred simply because some time has passed,*/
			/*not currently used in the program*/		
			break;

		default:
			
			break;
			
		}  /*end switch */
		
	}  /* end event loop */
	
	
	/*
	 * WRAP-UP
	 */
	GP142_close();         /* clean up and close graphics window   */
	
	return 0;
}  /*end main */

/*****************************************************************************

     FUNCTIONS

*****************************************************************************/
/* 
 * For a blank screen just draw a white rectangle that covers the whole
 * GP142 window.
 */
void DrawBlankScreen (void) {
	int font_size = 14;

	GP142_rectangleXY (WHITE,
					-GP142_XMAX, -GP142_YMAX,
					GP142_XMAX, GP142_YMAX,
					FILL);

} /*end DrawBlankScreen */


/* 
 * Draws the buttons 
 */
void DrawButtons(int last_button)
{
/* To add buttons, you'll need to change the #defined constant NUM_BUTTONS
 * and add messages to this array.  Although we haven't covered 2-D arrays
 * yet, you should be able to play with this enough to get it going.
 * Look at course packet, page N-25, for a similar example.
 */
	char b_labels [NUM_BUTTONS][25] = {
		"Background color",
		"Object color",
		"Next",
		"Add message",
		"Add shape",
		"Select object",
		"Delete object"
	};
	
	int i, text_offset = -GP142_XMAX + 6, font_size = 12;
	int y, label_y;
	
	/* draw rectangles and labels for each button */
	for(i = 0; i < NUM_BUTTONS; i++) {
		y = GP142_YMAX - i * BUTTON_HEIGHT;
		
		GP142_rectangleXY(BLACK,
			-GP142_XMAX + 4,
			y - 2,
			-GP142_XMAX + BUTTON_WIDTH,
			y - BUTTON_HEIGHT - 2, NOFILL);
	
		
		label_y = y - BUTTON_HEIGHT/2;
		
		if (i == last_button)
			GP142_printfXY(SELECTED_COLOR, text_offset, label_y, font_size + 1, b_labels[i]);	
		else
			GP142_printfXY(BLACK, text_offset, label_y, font_size, b_labels[i]);	
	}	
}


/*
 * Render (draw) the page and all its contents.
 */
void DrawCard (int background_color, int status, int object_count, 
			   int object_type[MAX_OBJECTS], int object_num[MAX_OBJECTS], 
			   int object_color[MAX_OBJECTS], int object_x[MAX_OBJECTS], int object_y[MAX_OBJECTS])
{
	int font_size = 14;
	int i;
	/*
	 * Draw the background of the card.
	 */
	GP142_rectangleXY (background_color,
		PAGE_LLX, PAGE_LLY,
		PAGE_LLX+ PAGE_WIDTH, PAGE_LLY+ PAGE_HEIGHT,
		FILL);

	GP142_printfXY (BLACK, PAGE_LLX-12, PAGE_LLY + PAGE_HEIGHT, font_size + 4,
		"YOUR PERSONAL GREETING CARD DESIGNER");
	GP142_printfXY (RED, PAGE_LLX-13, PAGE_LLY + PAGE_HEIGHT-1, font_size + 4,
		"YOUR PERSONAL GREETING CARD DESIGNER");
	
	GP142_printfXY (NAVY_BLUE, -GP142_XMAX + 5, -GP142_YMAX, font_size + 4, "Lisa Tuttle     9826652");
	GP142_printfXY (background_color, -GP142_XMAX + 6, -GP142_YMAX + 1, font_size + 4, "Lisa Tuttle     9826652");


	/* 
	 * Draw a shape on the card, if one currently exists.
	 */
	for (i=0; i <= object_count; i++)
	{
		switch (object_type[i])
		{
			case OBJECT_SHAPE:
				DrawShape (object_num[i], object_color[i], object_x[i], object_y[i]);
				break;
			case OBJECT_MESSAGE:
				DrawMessage (object_num[i], object_color[i], object_x[i], object_y[i]);
				break;
		}
	}

	DrawCupid (background_color);

	/*
	 * Write an appropriate status message below the background
	 */
	switch (status) {
	case STATUS_ADD_SHAPE:
		GP142_printfXY (RED, PAGE_LLX, PAGE_LLY-40, font_size+2,
			"Click on the card to add a shape");
		break;
	case STATUS_SELECTED:
		GP142_printfXY (RED, PAGE_LLX, PAGE_LLY-40, font_size-3,
			"Object selected. Click button to change shape.");
		break;
	case STATUS_ADD_MESSAGE:
		GP142_printfXY (RED, PAGE_LLX, PAGE_LLY-40, font_size+2,
			"Click on the card to add a message.");
		break;
	case STATUS_SELECT_OBJECT:
		GP142_printfXY (RED, PAGE_LLX, PAGE_LLY-40, font_size+2,
			"To select an object, click close to its origin.");
		break;
	case STATUS_DELETE_OBJECT:
		GP142_printfXY (RED, PAGE_LLX, PAGE_LLY-40, font_size+2,
			"To delete an object, first select it then click Delete Object.");
		break;
	default:
		GP142_printfXY (BLACK, PAGE_LLX, PAGE_LLY-40, font_size+2,
			"Status error -- notify programmer");
		break;
	} /*end switch */
	
	
} /*end DrawPage */


/*
 * Draw one shape.
 */
void DrawShape(int shape_type, int color, int bottom_x, int bottom_y) {

	switch ((shape_type - FIRST_SHAPE_NUM) % MAX_SHAPES) {
	case SHAPE_HEART:
		DrawHeart (bottom_x, bottom_y, color);
		break;
	case SHAPE_STAR:
		DrawStar (bottom_x, bottom_y, color);
		break;
	case SHAPE_SUPERSTAR:
		DrawSuperStar (bottom_x, bottom_y, color);
		break;
	case SHAPE_BALLOON:
		DrawBalloon (bottom_x, bottom_y, color);
		break;
	default:
		/* Unknown shape selected */
		break;

	} /*end switch*/

}


/*
 * Draw a heart on the card. A heart will be made by two overlapping
 * circles and a triangle.
 *
 * The pulsation is caused by adding a small, random amount to the 
 * heart height each time this function is called.
 */
#define HEART_WIDTH 35
void DrawHeart (int x, int y, int color) {
	int h = (HEART_WIDTH/2) + (rand () %4);
	GP142_circleXY (color, x - h + 5, y, h);
	GP142_circleXY (color, x + h - 5, y, h);
	GP142_triangleXY (color, x- h*2 +5, y-5,
						x + h*2 -5, y-5,
						x, y - h*2 -5, FILL);

}


/*
 * Draw a star on the card.
 *
 * We make the star twinkle by selecting the number of points randomly.  Each 
 * time it is redrawn, it is slightly different than the time before, which 
 * makes it appear to pulsate,
 */
#define STARPOINTS 5
#define STARRADIUS 40
#define PI 3.1416
void DrawStar (int x, int y, int color) {

	int sp;
	double angle;
	int x1, y1;

	sp = STARPOINTS + (rand () %3);
	for (angle = 0.0; angle < 2 * PI; angle = angle + (2*PI)/sp) {
		x1 = (int) (cos (angle) * STARRADIUS);
		y1 = (int) (sin (angle) * STARRADIUS);
		GP142_lineXY (color, x+x1, y+y1, x-x1, y-y1, 1);

	}
}

void DrawSuperStar (int x, int y, int color) {
	int addition = 30 + rand() % 10;
	int addition2 = addition - 15;
	GP142_triangleXY (color, x + 6, y + 6, x - 6, y + 6, x , y + addition, FILL);
	GP142_triangleXY (color, x + 6, y - 6, x - 6, y - 6, x , y - addition, FILL);
	GP142_triangleXY (color, x + 6, y + 6, x + 6, y - 6, x + addition, y, FILL);
	GP142_triangleXY (color, x - 6, y - 6, x - 6, y + 6, x - addition, y, FILL);
	GP142_triangleXY (color, x + 6, y, x, y - 6, x + addition2, y - addition2, FILL);
	GP142_triangleXY (color, x + 6, y, x, y + 6, x + addition2, y + addition2, FILL);
	GP142_triangleXY (color, x - 6, y, x, y + 6, x - addition2, y + addition2, FILL);
	GP142_triangleXY (color, x - 6, y, x, y - 6, x - addition2, y - addition2, FILL);
}

#define STRING 60
#define BALLOON_HEIGHT 50
#define BALLOON_WIDTH 20
void DrawBalloon (int x, int y, int color) {
	int y_string;
	int x_string = x;
	int option = 0;
	int width;
	int height;

	for (y_string = y; y_string > y - STRING; y_string = y_string - 1)
	{
		option = rand () % 2;
		switch (option)
		{
		case 1:
			x_string = x + (int)(2*sin(y_string));
			break;
		case 2:
			x_string = x + (int)(2*cos(y_string));
			break;
		}		
		GP142_pixelXY (BLACK, x_string, y_string);

	}
	
	height = BALLOON_HEIGHT + rand () % 6;
	width = BALLOON_WIDTH + rand () % 3;
	GP142_rectangleXY (color, x - 2, y + 2, x + 2, y - 5, FILL);
	GP142_ovalXY (color, x - width, y + height, x + width, y, FILL);	


}

/*Draws appropriate message object on card*/
void DrawMessage(int message_type, int color, int bottom_x, int bottom_y) {

	switch ((message_type - FIRST_MESSAGE_NUM) % MAX_MESSAGES) {
	case MESSAGE_ZERO:
		DrawText1 (bottom_x, bottom_y, color);
		break;
	case MESSAGE_ONE:
		DrawText2 (bottom_x, bottom_y, color);
		break;
	case MESSAGE_TWO:
		DrawText3 (bottom_x, bottom_y, color);
		break;
	case MESSAGE_THREE:
		DrawText4 (bottom_x, bottom_y, color);
		break;
	case MESSAGE_FOUR:
		DrawText5 (bottom_x, bottom_y, color);
		break;
	default:
		/* Unknown message selected */
		break;

	} /*end switch*/

} /*end of DrawMessage*/

/*display text mesage functions called by AddMessage function*/
void DrawText1 (int x, int y, int color)
{
	int h = (rand () % 3);
	int font_size = 13;
	GP142_printfXY (color, x, y, font_size + h, "Be Mine");
}

void DrawText2 (int x, int y, int color)
{
	int h = (rand () % 3);
	int font_size = 13;
	GP142_printfXY (color, x, y, font_size + h, "True Love");
}

void DrawText3 (int x, int y, int color)
{
	int h = (rand () % 3);
	int font_size = 13;
	GP142_printfXY (color, x, y, font_size + h, "Be My Valentine");
}

void DrawText4 (int x, int y, int color)
{
	int h = (rand () % 3);
	int font_size = 13;
	GP142_printfXY (color, x, y, font_size + h, "I Love You");
}

void DrawText5 (int x, int y, int color)
{
	int h = (rand () % 3);
	int font_size = 13;
	GP142_printfXY (color, x, y, font_size + h, "Love you lots!");
}
/*end of text functions*/


/*computes the distance between two points*/
double PointDistance (int x1, int y1, int x2, int y2)
{
	return sqrt ((x1-x2)*(x1-x2) + (y1-y2)*(y1-y2));
}

/*function called if status is STATUS_SELECT_OBJECT after mouse click 
  on card and if there are objects on the page                               */
int ObjectSelect (int mouse_x, int mouse_y, int object_count, 
				  int object_x[MAX_OBJECTS], int object_y[MAX_OBJECTS])
{
	int i, closeobject;
	double current_distance, nearest_distance;
	
	for (i = 0; i <= object_count; i++)
	{
		current_distance = PointDistance (mouse_x, mouse_y, object_x[i], object_y[i]);
		if (i == 0)
		{
			nearest_distance = current_distance;
			closeobject = i;
		}
		if (current_distance <= nearest_distance)
		{
			nearest_distance = current_distance;
			closeobject = i;
		}
	}
	if (nearest_distance <= 10) /*selection most occur w/in 10 pixels of object origin*/
		return closeobject;
	return -1;  /*object is not close enough to be selected*/
}

/*draws cupid looking guy in bottom left portion of screen*/
#define CUPID_HEART_WIDTH 8
void DrawCupid (int color)
{
	int h = (CUPID_HEART_WIDTH/2) + (rand () % 2);
	int x, y;
	int color2 = (color + 2) % MAX_COLORS;
	color = (color + 1) % MAX_COLORS;

	/*keep color non-white*/
	if (color == WHITE)
		color++;
	if (color2 == WHITE)
		color2++;

	GP142_circleXY (BLACK, -GP142_XMAX + 70, -GP142_YMAX + 200, 15); //head
	GP142_circleXY (WHITE, -GP142_XMAX + 70, -GP142_YMAX + 200, 13);
	GP142_circleXY (BLACK, -GP142_XMAX + 65, -GP142_YMAX + 205, 1);	  //left eye
	GP142_circleXY (BLACK, -GP142_XMAX + 75, -GP142_YMAX + 205, 1);	  //right eye

	GP142_ovalXY (BLACK, -GP142_XMAX + 65, -GP142_YMAX + 200,		  //smile
							 -GP142_XMAX + 77, -GP142_YMAX + 192, 2);
	GP142_rectangleXY (WHITE, -GP142_XMAX + 61, -GP142_YMAX + 203,
							 -GP142_XMAX + 77, -GP142_YMAX + 197, FILL);

	GP142_lineXY (BROWN, -GP142_XMAX + 54, -GP142_YMAX + 184,      //arrow
					-GP142_XMAX + 80, -GP142_YMAX + 140, 2);
	
	GP142_lineXY (BROWN, -GP142_XMAX + 45, -GP142_YMAX + 182,      //arrow
					-GP142_XMAX + 80, -GP142_YMAX + 140, 2);

	GP142_lineXY (color2, -GP142_XMAX + 60, -GP142_YMAX + 170,      //bag
					-GP142_XMAX + 80, -GP142_YMAX + 140, 12);

	GP142_lineXY (BLACK, -GP142_XMAX + 70, -GP142_YMAX + 185,      //torso
					-GP142_XMAX + 70, -GP142_YMAX + 135, 2);

	GP142_lineXY (color, -GP142_XMAX + 70, -GP142_YMAX + 175,      //strap
					-GP142_XMAX + 60, -GP142_YMAX + 155, 2);

	GP142_lineXY (BLACK, -GP142_XMAX + 95, -GP142_YMAX + 100,     //leg one part
					-GP142_XMAX + 70, -GP142_YMAX + 135, 2);

	GP142_lineXY (BLACK, -GP142_XMAX + 45, -GP142_YMAX + 110,      //leg two part
					-GP142_XMAX + 70, -GP142_YMAX + 135, 2);

	GP142_lineXY (BLACK, -GP142_XMAX + 95, -GP142_YMAX + 100,      //end of leg one
					-GP142_XMAX + 70, -GP142_YMAX + 75, 2);

	GP142_lineXY (BLACK, -GP142_XMAX + 45, -GP142_YMAX + 110,      //end of leg two
					-GP142_XMAX + 25, -GP142_YMAX + 130, 2);

	GP142_lineXY (BLACK, -GP142_XMAX + 70, -GP142_YMAX + 75,      //foot one
					-GP142_XMAX + 80, -GP142_YMAX + 60, 2);

	GP142_lineXY (BLACK, -GP142_XMAX + 25, -GP142_YMAX + 130,      //foot two
					-GP142_XMAX + 15, -GP142_YMAX + 120, 2);

	GP142_lineXY (BLACK, -GP142_XMAX + 70, -GP142_YMAX + 175,      //arm one part one 
					-GP142_XMAX + 95, -GP142_YMAX + 168, 2);

	GP142_lineXY (BLACK, -GP142_XMAX + 100, -GP142_YMAX + 160,      //arm one part two
					-GP142_XMAX + 95, -GP142_YMAX + 168, 2);

	GP142_lineXY (BLACK, -GP142_XMAX + 70, -GP142_YMAX + 175,      //arm two part one
					-GP142_XMAX + 80, -GP142_YMAX + 155, 2);

	GP142_lineXY (BLACK, -GP142_XMAX + 100, -GP142_YMAX + 155,      //arm two part two
					-GP142_XMAX + 80, -GP142_YMAX + 155, 2);

	GP142_lineXY (color, -GP142_XMAX + 100, -GP142_YMAX + 185,      //bow
					-GP142_XMAX + 100, -GP142_YMAX + 135, 2);

	GP142_lineXY (color, -GP142_XMAX + 100, -GP142_YMAX + 185,      //bow string top
					-GP142_XMAX + 125, -GP142_YMAX + 160, 2);

	GP142_lineXY (color, -GP142_XMAX + 100, -GP142_YMAX + 135,      //bow string bottom
					-GP142_XMAX + 125, -GP142_YMAX + 160, 2);

	GP142_lineXY (BROWN, -GP142_XMAX + 100, -GP142_YMAX + 160,      //arrow
					-GP142_XMAX + 145, -GP142_YMAX + 160, 2);

	x = -GP142_XMAX + 145;											//heart on arrow
	y = -GP142_YMAX + 160;
	GP142_circleXY (color2, x, y + 4, h);
	GP142_circleXY (color2, x, y - 4, h);
	GP142_triangleXY (color2, x, y + 2 * h,	x, y- 2 *h,	x + 3 * h, y, FILL);
} /*end DrawCupid*/


/*
 * Mouse clicks occur in one of three regions of interest: on buttons, 
 * on the card, or anywhere else.
 */
int  ClassifyMouseClick(int mouse_x, int mouse_y)
{
  if ((mouse_x < -GP142_XMAX + BUTTON_WIDTH) &&
      (mouse_y < GP142_YMAX) &&
      (mouse_y > (GP142_YMAX - NUM_BUTTONS*BUTTON_HEIGHT)))
    return CLICK_BUTTON;
  else if (mouse_x >= PAGE_LLX && mouse_x < PAGE_LLX + PAGE_WIDTH
	  && mouse_y >= PAGE_LLY && mouse_y < PAGE_LLY + PAGE_HEIGHT)
    return CLICK_CARD;
  else
    return CLICK_OUTSIDE;

}


/*
 * Decide where a mouse click occured, and react appropriately.
 */
void HandleMouseClick(int mouse_x, int mouse_y, int *background_color, 
					  int *status, int *object_count, int object_type[MAX_OBJECTS], 
					  int object_num[MAX_OBJECTS], int object_color[MAX_OBJECTS], 
					  int object_x[MAX_OBJECTS], int object_y[MAX_OBJECTS], 
					  int *last_button, int *selected_object)
{
	int mouse_click, selected;
	mouse_click = ClassifyMouseClick(mouse_x, mouse_y);
			
	if (mouse_click == CLICK_BUTTON) 
	{				
		/* A button has been clicked.  Call a function to handle it*/
		/* most of the variables passed as args will NOT change*/
		HandleButton(mouse_x, mouse_y, background_color, status, 
				object_count, object_type, 
				object_num, object_color, object_x, object_y,
				last_button, selected_object);
	} 
	else if (mouse_click == CLICK_CARD) {
		/* Add a shape, if there isn't one already */
		if ((*status == STATUS_SELECT_OBJECT) && (*object_count > 0))
		{
			selected = ObjectSelect (mouse_x, mouse_y, *object_count, 
				object_x, object_y);
			if (selected != -1) 
			{
				*selected_object = selected;
				*status = STATUS_SELECTED;
				object_x[*selected_object] = mouse_x;
				object_y[*selected_object] = mouse_y;
			}
		}
		AddShape(mouse_x, mouse_y, status, object_count, selected_object, 
				  object_type, object_num, object_color, 
				  object_x, object_y);
	}

	/* Ignore any other mouse clicks */
}

/* 
 * Figure out which button was clicked, if any, and do the right 
 * thing.
 */
void HandleButton(int x, int y, int *background_color, int *status,
				  int *object_count, int object_type[MAX_OBJECTS], int object_num[MAX_OBJECTS], 
				  int object_color[MAX_OBJECTS], int object_x[MAX_OBJECTS], int object_y[MAX_OBJECTS],
				  int *last_button, int *selected_object)
{
	int buttonNum = 0;
	int last_status;
		
	/* If we're outside of this area, we could not have clicked on
	* a button.
	*/
	if (x > -GP142_XMAX + BUTTON_WIDTH)  
		return ;	/*That's an error situation*/
	
	/* We know the mouse clicked in the column of buttons. Calculate
	* which one.
	*/
	buttonNum = (GP142_YMAX - y)/BUTTON_HEIGHT;	 
	
	switch(buttonNum) {
	case 0:
		/* Change the background color */
		*background_color = (*background_color + 1) % MAX_COLORS;
		*last_button = buttonNum;
		break;
	case 1:
		/*Change the color of the currently selected object */
		object_color[*selected_object] = (object_color[*selected_object] + 1) % MAX_COLORS;
		*last_button = buttonNum;
		break;
	case 2:
		/* Change the type of the currently selected object */
		if (object_type[*selected_object] == OBJECT_SHAPE)
			object_num[*selected_object] = (object_num[*selected_object] + 1) % MAX_SHAPES;
		if (object_type[*selected_object] == OBJECT_MESSAGE)
			object_num[*selected_object] = (object_num[*selected_object] + 1) % MAX_MESSAGES;
		*last_button = buttonNum;
		break;
	case 3:
		/*change status so message is added in AddShape function*/
		last_status = *status;
		*status = STATUS_ADD_MESSAGE;
		*last_button = buttonNum;
		if (*object_count < MAX_OBJECTS - 1)
		{
			*object_count = *object_count + 1;
			*selected_object = *object_count;
		}
		break;
	case 4:
		/*change status so shape is added in AddShape function*/
		last_status = *status;
		*status = STATUS_ADD_SHAPE;
		*last_button = buttonNum;
		if (*object_count < MAX_OBJECTS - 1)
		{
			*object_count = *object_count + 1;
			*selected_object = *object_count;
		}
		break;
	case 5:
		/*change status so select object message is displayed*/
		*status = STATUS_SELECT_OBJECT;
		*last_button = buttonNum;
		break;
	case 6:
		/*deletes an object if selected, an object just added is already selected*/
		last_status = *status; /*we need to know if an object is selected*/
		*status = STATUS_DELETE_OBJECT;
		if (last_status == STATUS_SELECTED  || *selected_object == *object_count)
		{
			object_type[*selected_object] = OBJECT_NONE;
			object_num[*selected_object] = 0;
			object_color[*selected_object] = WHITE;
			object_x[*selected_object] = GP142_XMAX;
			object_y[*selected_object] = GP142_YMAX;
		}
		*last_button = buttonNum;
		break;

	default:
		*status = 999;
		/*Bad news if this is ever reached! */
		break;
	}
}


/* If there's room for another shape, add it to the card. */
void AddShape(int x, int y, int *status, int *object_count, int *selected_object,
			   int object_type[MAX_OBJECTS], int object_num[MAX_OBJECTS], int object_color[MAX_OBJECTS], 
			   int object_x[MAX_OBJECTS], int object_y[MAX_OBJECTS])
{
	int last_status = *status;
	if (*object_count < MAX_OBJECTS) 
	{
		if (*status == STATUS_SELECTED) /*allows user to move selected object*/
		{
			object_x[*selected_object] = x;
			object_y[*selected_object] = y;
		}
		else
		{
			*status = STATUS_SELECTED; /*newly made object is slected*/
			object_x[*object_count] = x;
			object_y[*object_count] = y;
		}
		if (last_status ==  STATUS_ADD_SHAPE) /*add a shape*/
		{			
			object_type[*object_count] = OBJECT_SHAPE;
			object_num[*object_count] = SHAPE_HEART;		
			object_color[*object_count] = RED;					
		}
		if (last_status == STATUS_ADD_MESSAGE) /*add a message*/
		{
			object_type[*object_count] = OBJECT_MESSAGE;
			object_num[*object_count] = MESSAGE_ZERO;
			object_color[*object_count] = RED;	
		}
	}
}
